--List files that have been added to
--your Euphoria directory.
--Uses list.txt for listing of files
--that came in the "official" distribution.
--
--Written by Joseph Martin.
--Copy freely. In PD as long as I'm given credit for the *orginal*
--program.

without warning

include file.e
include joe.e
include sort.e
include zeitlin.e

sequence official, eudir, list, dirs, added
atom tmp, fn

eudir = getenv("EUDIR")
dirs = {}
list = {}
added = {}
procedure walk_dir(sequence path_name)
    object d
    sequence name, full_path
    
	d = dir(path_name)

	while find(path_name[length(path_name)], " \\") do
		path_name = path_name[1..length(path_name)-1]
	end while

	if atom(d) then
		puts(2, "Couldn't open " & path_name & '\n')
	end if

	for i = 1 to length(d) do
		name = d[i][D_NAME]
		if not find(name, {".", ".."}) then
			full_path = path_name & '\\' & name
				if find('d', d[i][D_ATTRIBUTES]) then -- directory
					walk_dir(full_path)
				else -- file
					list = append(list, full_path)
				end if
			end if
		end for
end procedure

official = load_text("list.txt")

for i = 1 to length(official) do
	official[i] = trim(official[i])
end for

for i = 1 to length(official) do
	official[i] = eudir & '\\' & official[i]
end for

walk_dir(eudir)

for i = 1 to length(list) do
	tmp = find(list[i], official)
	if tmp = 0 then
		added = append(added, list[i])
	end if
end for

added = sort(added)

fn = open("added.txt", "w")
for i = 1 to length(added) do
	printf(fn, "%s\n", {added[i]})
end for
close(fn)
